<template>
    <div class="app">
        <v-card class="vuety" max-width="1150px" min-height="600px" style="margin-left: 12%">
            <v-card-title class="bee-gray">
                <v-row justify="center">
                    <v-col cols="12">
                        <v-row align="center">
                            <v-col cols="3">
                                <a @click="$router.go(-1)">
                                    <img width="70px" src="~@/assets/icons/regresar.svg" alt srcset />
                                </a>
                            </v-col>
                            <v-col cols="2">
                                <h5 class="titleBack">Regresar</h5>
                            </v-col>
                        </v-row>
                    </v-col></v-row
                >
                <v-spacer></v-spacer>
            </v-card-title>

            <div class="d-flex black" style="width:100%; position: relative; margin-top:-220px;">
                <h1 class="ml-10 white--text">{{ getRestaurantName(this.$route.params.id).toUpperCase() }}</h1>
                <v-spacer></v-spacer>
            </div>
            <div class="d-flex" style="width:100%;">
                <v-row no-gutters align="center" style="zoom: 100%; margin-bottom: 30px;">
                    <v-col cols="1">
                        <v-spacer></v-spacer>
                    </v-col>
                </v-row>
            </div>

            <v-card flat>
                <v-toolbar flat>
                    <span style="color: #72727f; font-weight:bold; padding-left: 5px; font-size: 1rem;">BUSCAR:</span>
                    <v-text-field
                        v-model="search"
                        append-icon="mdi-magnify"
                        label="Número de pedido, Mesa, Comensal..."
                        single-line
                        hide-details
                        color="black"
                        style="
                                    max-width: 600px; 
                                    padding-left: 10px; 
                                    padding-right: 20px; 
                                    text-justify: distribute-all-lines; 
                                    background-color: #FFFFFF;"
                        class="searchAuto"
                    >
                    </v-text-field>
                </v-toolbar>
                <v-tabs
                    ref="tabs"
                    v-model="hello"
                    background-color="#f9fafd"
                    color="#333;"
                    style="border-radius: 0;"
                    show-arrows
                >
                    <v-tabs-slider></v-tabs-slider>
                    <v-tab
                        style="font-weight:bold; font-size: small; border-radius: 0;"
                        v-for="tab in getTabs"
                        :key="tab.name"
                    >
                        {{ tab.name }}
                    </v-tab>
                </v-tabs>
            </v-card>

            <v-tabs-items v-model="hello">
                <v-tab-item v-for="tab in getTabs" :key="tab.name">
                    <v-data-table
                        :headers="tab.headers"
                        :items="tab.orderList"
                        item-key="name"
                        :search="search"
                        class="elevation-1"
                        :must-sort="false"
                        :sort-by="['updatedAt']"
                        :sort-desc="[true]"
                    >
                        <template v-slot:no-data>
                            <v-alert :value="true" color="alert">
                                No se encontaron ordenes en la comanda por el momento.
                            </v-alert>
                        </template>
                        <template v-slot:item="row" class="d-flex">
                            <tr>
                                <td>{{ row.item.numberOrder }}</td>
                                <td class="text-xs-right">{{ row.item.name }}</td>
                                <td class="text-xs-right">
                                    {{ row.item.type === types.LOCAL ? row.item.location : row.item.phone }}
                                </td>
                                <td class="text-xs-right">{{ formatDate(row.item.createdAt) }}</td>
                                <td class="text-xs-right">{{ row.item.type }}</td>
                                <td class="text-xs-right">
                                    <template>
                                        <v-btn
                                            icon
                                            small
                                            class="meter-point-options-menu action-column-item"
                                            @click.stop="$set(dialogItem, row.item.id, true)"
                                        >
                                            <HexButton style="background-color: #FBC02D;" class="btnHex">
                                                <v-icon>mdi-eye</v-icon>
                                            </HexButton>
                                        </v-btn>
                                    </template>
                                    <v-dialog
                                        v-model="dialogItem[row.item.id]"
                                        scrollable
                                        max-width="800"
                                        :key="row.item.id"
                                    >
                                        <v-card>
                                            <div
                                                class="d-flex black"
                                                style="width:100%; height: 80px; padding-top: 20px; "
                                            >
                                                <h1 class="ml-10 white--text">PEDIDO #{{ row.item.numberOrder }}</h1>
                                                <v-spacer></v-spacer>
                                            </div>
                                            <v-card-title class="headline"> </v-card-title>
                                            <v-card-text>
                                                <dish-item
                                                    :order-id="row.item.id"
                                                    :order-list="tab.orderList"
                                                ></dish-item>
                                            </v-card-text>
                                            <v-divider></v-divider>
                                            <v-card-text>
                                                <v-btn
                                                    color="primary"
                                                    text
                                                    @click.stop="$set(dialogItem, row.item.id, false)"
                                                    >CERRAR
                                                </v-btn>
                                            </v-card-text>
                                        </v-card>
                                    </v-dialog>
                                </td>
                                <td class="text-xs-right">
                                    <v-col class="d-flex">
                                        <v-btn
                                            :v-model="row.item.status"
                                            v-for="options in tab.options"
                                            :key="options.id"
                                            @click="itemselect(options, row.item.id)"
                                            :color="options === 'COMPLETED' ? '' : '#ccc'"
                                            style="color:#1976d2; caret-color:#1976d2;  margin:8px; justify-items: flex-end;"
                                            :disabled="tab.customDisabled"
                                            >{{ options }}</v-btn
                                        >
                                    </v-col>
                                </td>
                            </tr>
                        </template>
                    </v-data-table>
                </v-tab-item>
            </v-tabs-items>

            <v-dialog v-model="message.show" rounded="" max-width="290">
                <v-alert
                    style="text-align:center; margin:0px;"
                    justify="center"
                    v-model="message.show"
                    dismissible
                    :type="message.type"
                    >{{ message.message }}</v-alert
                >
            </v-dialog>
        </v-card>
    </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { Action, namespace } from 'vuex-class';
import { Order, StatusOrder, TypeOrder } from '@/model/order/Order';
import DishItem from '@/components/order/DishItem.vue';
import { Restaurant } from '@/model/Restaurant';
import HexButton from '@/components/commons/HexButton.vue';
import { AsyncComponentPromise } from 'vue/types/options';
import { PaymentStatus } from '@/model/order/GatewayOrder';

const restaurantStore = namespace('RestaurantModule');
const orderStore = namespace('OrderModule');

@Component({
    components: {
        DishItem,
        HexButton
    }
})
export default class Orders extends Vue {
    @restaurantStore.State
    restaurants!: Restaurant[];

    @orderStore.State
    orders!: Order[];

    @orderStore.Action
    findOrdersForRestaurant!: (restaurantId: string) => AsyncComponentPromise<string>;

    @orderStore.Action
    changeStatusOrder!: (payload: { orderId: string; status: string }) => Promise<void>;

    @Action('changeShowHomeIcon')
    changeShowHomeIcon!: (payload: boolean) => Promise<void>;

    tabs: { name: string; headers: object[]; orderList: Order[]; options: string[]; customDisabled: boolean }[] = [];
    types = TypeOrder;
    hello = '';
    dialogItem = {};
    urlRef = '';

    async created() {
        this.urlRef = this.$route.params.id;
        await this.findOrdersForRestaurant(this.$route.params.id);
        this.tabInit();
    }

    updated() {
        if (this.$route.params.id !== this.urlRef) {
            location.reload();
            this.urlRef = this.$route.params.id;
        }
    }

    get localOrdersCompleted(): Order[] {
        const localOrder = this.orders.filter(
            order =>
                order.type === TypeOrder.LOCAL &&
                order.status === StatusOrder.COMPLETED &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED
        );
        return localOrder;
    }
    get localOrdersPending(): Order[] {
        const localOrder = this.orders.filter(
            order =>
                order.type === TypeOrder.LOCAL &&
                order.status === StatusOrder.PENDING &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED
        );
        return localOrder;
    }

    get deliveryOrdersCompleted(): Order[] {
        const deliveryOrder = this.orders.filter(
            order =>
                order.detailsPayment &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED &&
                order.detailsPayment?.status !== PaymentStatus.CANCELED &&
                order.type === TypeOrder.DELIVERY &&
                order.status === StatusOrder.COMPLETED
        );
        return deliveryOrder;
    }

    get deliveryOrdersPending(): Order[] {
        const deliveryOrder = this.orders.filter(
            order =>
                order.detailsPayment &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED &&
                order.detailsPayment?.status !== PaymentStatus.CANCELED &&
                order.type === TypeOrder.DELIVERY &&
                order.status === StatusOrder.PENDING
        );
        return deliveryOrder;
    }
    get deliveryOrdersCanceled(): Order[] {
        const deliveryOrder = this.orders.filter(
            order =>
                order.detailsPayment &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED &&
                order.detailsPayment?.status !== PaymentStatus.CANCELED &&
                order.type === TypeOrder.DELIVERY &&
                order.status === StatusOrder.CANCEL
        );
        return deliveryOrder;
    }

    get deliveryCollectPending(): Order[] {
        const deliveryOrder = this.orders.filter(
            order =>
                order.detailsPayment &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED &&
                order.detailsPayment?.status !== PaymentStatus.CANCELED &&
                order.type === TypeOrder.COLLECT &&
                order.status === StatusOrder.PENDING
        );
        return deliveryOrder;
    }

    get deliveryCollectCompleted(): Order[] {
        const deliveryOrder = this.orders.filter(
            order =>
                order.detailsPayment &&
                order.detailsPayment?.status !== PaymentStatus.DECLINED &&
                order.detailsPayment?.status !== PaymentStatus.CANCELED &&
                order.type === TypeOrder.COLLECT &&
                order.status === StatusOrder.COMPLETED
        );
        return deliveryOrder;
    }

    getRestaurantName(restId: string) {
        const rest = this.restaurants.find(p => p.id == restId);
        if (rest == undefined) {
            return '';
        }
        return rest.name;
    }
    get getTabs() {
        this.tabInit();
        return this.tabs;
    }

    //select options
    itemsLocalPending = [StatusOrder.COMPLETED];
    itemsLocalCompleted = [StatusOrder.COMPLETED];
    itemsDeliveryCompleted = [StatusOrder.COMPLETED];
    itemsDeliveryCancel = [StatusOrder.CANCEL];
    itemsDeliveryPending = [StatusOrder.COMPLETED, StatusOrder.CANCEL];
    itemsCollectPending = [StatusOrder.COMPLETED];
    itemsCollectCompleted = [StatusOrder.COMPLETED];

    message: { message: string; type: 'success' | 'info' | 'warning' | 'error'; show: boolean } = {
        message: '',
        type: 'error',
        show: false
    };

    headersLocal = [
        { text: 'NÚMERO PEDIDO', align: 'center', sortable: false, value: 'numberOrder' },
        { text: 'NOMBRE ', align: 'center', sortable: false, value: 'name' },
        { text: 'MESA', align: 'center', sortable: false, value: 'location' },
        { text: 'FECHA', align: 'center', sortable: false, value: 'updatedAt', type: Date },
        { text: 'TIPO', align: 'center', sortable: false, value: 'type' },
        { text: 'VER', align: 'center', sortable: false, value: 'id' },
        { text: 'ESTATUS', align: 'center', sortable: false, value: 'status' }
    ];

    headersDelivery = [
        { text: 'NÚMERO PEDIDO', align: 'center', sortable: false, value: 'numberOrder' },
        { text: 'NOMBRE ', align: 'center', sortable: false, value: 'name' },
        { text: 'TELEFONO', align: 'center', sortable: false, value: 'phone' },
        { text: 'FECHA', align: 'center', sortable: false, value: 'updatedAt', type: Date },
        { text: 'TIPO', align: 'center', sortable: false, value: 'type' },
        { text: 'VER', align: 'center', sortable: false, value: 'id' },
        { text: 'ESTATUS', align: 'center', sortable: false, value: 'status' }
    ];

    //set itemTabs content
    tabInit() {
        this.tabs = [
            {
                name: 'PENDIENTES LOCAL',
                headers: this.headersLocal,
                orderList: this.localOrdersPending,
                options: this.itemsLocalPending,
                customDisabled: false
            },
            {
                name: 'COMPLETADAS LOCAL',
                headers: this.headersLocal,
                orderList: this.localOrdersCompleted,
                options: this.itemsLocalCompleted,
                customDisabled: true
            },
            {
                name: 'PENDIENTES DOMICILIO',
                headers: this.headersDelivery,
                orderList: this.deliveryOrdersPending,
                options: this.itemsDeliveryPending,
                customDisabled: false
            },
            {
                name: 'COMPLETADAS DOMICILIO',
                headers: this.headersDelivery,
                orderList: this.deliveryOrdersCompleted,
                options: this.itemsDeliveryCompleted,
                customDisabled: true
            },
            {
                name: 'CANCELADAS DOMICILIO',
                headers: this.headersDelivery,
                orderList: this.deliveryOrdersCanceled,
                options: this.itemsDeliveryCancel,
                customDisabled: true
            },
            {
                name: 'PENDIENTES PICKUP',
                headers: this.headersDelivery,
                orderList: this.deliveryCollectPending,
                options: this.itemsCollectPending,
                customDisabled: false
            },
            {
                name: 'COMPLETADAS PICKUP',
                headers: this.headersDelivery,
                orderList: this.deliveryCollectCompleted,
                options: this.itemsCollectCompleted,
                customDisabled: true
            }
        ];
    }

    search = '';

    formatDate(d: Date) {
        const DateTimeF = d.toLocaleDateString() + '  -  ' + d.toLocaleTimeString();
        return DateTimeF;
    }

    itemselect(status: string, orderId: string) {
        switch (status) {
            case (status = StatusOrder.COMPLETED):
                if (confirm('¿Realmente quieres COMPLETAR este pedido?')) {
                    this.changeStatusOrder({ orderId: orderId, status: status });
                    this.message = { message: 'STATUS DE PEDIDO ACTUALIZADO', type: 'success', show: true };
                }
                break;
            case (status = StatusOrder.CANCEL):
                if (confirm('¿Realmente quieres CANCELAR este pedido?')) {
                    this.changeStatusOrder({ orderId: orderId, status: status });
                    this.message = { message: 'STATUS DE PEDIDO ACTUALIZADO', type: 'success', show: true };
                }
                break;
            default:
                this.changeStatusOrder({ orderId: orderId, status: status });
                this.message = { message: 'STATUS DE PEDIDO ACTUALIZADO', type: 'success', show: true };
                break;
        }
    }
}
</script>

<style type="scss">
.v-menu__content {
    margin: 0px !important;
}

.v-tab {
    border-radius: 20px;
    background: #fbc02d;
    display: flex;
    justify-content: center;
}
.theme--light.v-tabs > .v-tabs-bar .v-tab:not(.v-tab--active) {
    background: #f9fafd;
    color: black;
}
.div.v-tab.v-tab--active {
    color: inherit;
    background: #fbc02d;
}
@media screen and (max-width: 700px) {
    .v-slide-group__content {
        display: -webkit-box;
    }
    .v-tab {
        border-radius: 20px;
        background: #fbc02d;
        display: -webkit-box;
        justify-content: center;
        margin-top: 20px;
        width: 10px;
    }
    .titleBack {
        width: 100px;
        height: 100px;
        margin-right: 80px;
    }
    .tbars {
        position: absolute;
        margin-top: -10px;
    }
    .searchTitle {
        font-size: 14px;
    }
    .v-input__slot {
        position: relative;
        width: 70%;
    }

    .btnHex {
        width: 40px;
        height: 40px;
    }
    .mdi-eye::before {
        content: '\F0208';
        width: 15px;
        height: 15px;
        position: revert;
        margin-top: -20px;
        margin-right: 20px;
    }
}
</style>
